unit u_prep_query_cgd_movimentos;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, DBCtrls,
  ExtCtrls, EditBtn, BGRACustomDrawn,
  RTTICtrls, LSControls, SynEdit;

type
  { Tfrm_prep_query_cgd_movimentos }

  Tfrm_prep_query_cgd_movimentos = class(TForm)
    B_ExecQuery: TButton;
    B_Limpar: TButton;
    B_Sair: TButton;
    CB_op_analisado: TComboBox;
    CB_op_categoria: TComboBox;
    CB_op_cod_tipo_movimento: TComboBox;
    CB_op_credito: TComboBox;
    CB_op_data_mov: TComboBox;
    CB_op_data_valor: TComboBox;
    CB_op_debito: TComboBox;
    CB_op_descricao: TComboBox;
    CB_op_pk_movimento: TComboBox;
    CB_op_saldo_contabilistico: TComboBox;
    CB_op_saldo_disponivel: TComboBox;
    E_analisado: TEdit;
    E_categoria: TEdit;
    E_cod_tipo_movimento: TEdit;
    E_credito: TEdit;
    E_data_mov: TEdit;
    E_data_valor: TEdit;
    E_debito: TEdit;
    E_descricao: TEdit;
    E_PK_movimento: TEdit;
    E_saldo_contabilistico: TEdit;
    E_saldo_disponivel: TEdit;
    L_analisado: TLabel;
    L_categoria: TLabel;
    L_cod_tipo_movimento: TLabel;
    L_credito: TLabel;
    L_data_mov: TLabel;
    L_data_valor: TLabel;
    L_debito: TLabel;
    L_descricao: TLabel;
    L_PK_movimento: TLabel;
    L_saldo_contabilistico: TLabel;
    L_saldo_disponivel: TLabel;
    procedure B_ExecQueryClick(Sender: TObject);
    procedure B_LimparClick(Sender: TObject);
    procedure B_SairClick(Sender: TObject);
    procedure CB_op_analisadoChange(Sender: TObject);
    procedure CB_op_categoriaChange(Sender: TObject);
    procedure CB_op_cod_tipo_movimentoChange(Sender: TObject);
    procedure CB_op_creditoChange(Sender: TObject);
    procedure CB_op_data_movChange(Sender: TObject);
    procedure CB_op_data_valorChange(Sender: TObject);
    procedure CB_op_debitoChange(Sender: TObject);
    procedure CB_op_descricaoChange(Sender: TObject);
    procedure CB_op_pk_movimentoChange(Sender: TObject);
    procedure CB_op_saldo_contabilisticoChange(Sender: TObject);
    procedure CB_op_saldo_disponivelChange(Sender: TObject);
    procedure E_analisadoEnter(Sender: TObject);
    procedure E_categoriaEnter(Sender: TObject);
    procedure E_cod_tipo_movimentoEnter(Sender: TObject);
    procedure E_creditoEnter(Sender: TObject);
    procedure E_data_movEnter(Sender: TObject);
    procedure E_data_valorEnter(Sender: TObject);
    procedure E_debitoEnter(Sender: TObject);
    procedure E_descricaoEnter(Sender: TObject);
    procedure E_PK_movimentoEnter(Sender: TObject);
    procedure E_saldo_contabilisticoEnter(Sender: TObject);
    procedure E_saldo_disponivelEnter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private

  public

  end;

var
  frm_prep_query_cgd_movimentos: Tfrm_prep_query_cgd_movimentos;
  c_where,
  clausula_where,
  SQL_text: string;

  op_PK_movimento,
  op_data_mov,
  op_data_valor,
  op_descricao,
  op_debito,
  op_credito,
  op_saldo_contabilistico,
  op_saldo_disponivel,
  op_categoria,
  op_cod_tipo_movimento,
  op_analisado: string;

implementation
  uses u_dm_movimentos, u_edita_cgd_movimentos;

{$R *.frm}

{ Tfrm_prep_query_cgd_movimentos }

procedure Tfrm_prep_query_cgd_movimentos.CB_op_categoriaChange(Sender: TObject);
begin
  case CB_op_categoria.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_categoria := '>';
    1: op_categoria := '<';
    2: op_categoria := '=';
    3: op_categoria := '<=';
    4: op_categoria := '>=';
    5: op_categoria := 'between';
    6: op_categoria := 'like';
  end;
end;

procedure Tfrm_prep_query_cgd_movimentos.CB_op_analisadoChange(Sender: TObject);
begin
  case CB_op_analisado.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_analisado := '>';
    1: op_analisado := '<';
    2: op_analisado := '=';
    3: op_analisado := '<=';
    4: op_analisado := '>=';
    5: op_analisado := 'between';
    6: op_analisado := 'like';
  end;
end;

procedure Tfrm_prep_query_cgd_movimentos.B_ExecQueryClick(Sender: TObject);
  var
  field_no: integer;
  field_nome,
  field_tipo: string;

  menor_que: string = #60;
  igual_a: string = #61;
  maior_que: string = #62;
  menor_ou_igual: string = '<=';
  maior_ou_igual: string = '>=';
  like: string = 'like';
  between: string = 'between';
  interrogacao: string = 'SQL_livre';   //#63;
  percentagem: string = #37;
  espaco: string = #32;
  plica: string = #39;

begin
  while field_no < frm_dm_movimentos.SQLQ_movimentos_CGD.FieldCount do
  begin
    field_no := field_no + 1;
    field_nome := frm_dm_movimentos.SQLQ_movimentos_CGD.Fields.FieldByNumber(field_no).DisplayName;
//    Field_tipo := SQLQ_movimentos.Fields.FieldByName(field_nome);
//    showmessage(SQLQ_movimentos.Params[field_no].DisplayName);
//    showmessage(DBG_movimentos.Columns.Items[field_no].DisplayFormat);    não mostra nada porque a grelha não tem formato para as colunas
//interessante    showmessage('Field_nome:  ' + field_nome);
  end;


// forma a claúsula WHERE para dar seguimento à QUERY
  clausula_where := 'where 1 = 1 ';
  if E_PK_movimento.Text <> '' then
  begin
    if (op_PK_movimento = igual_a) or (op_PK_movimento = menor_que) or (op_PK_movimento = maior_que) or (op_PK_movimento = menor_ou_igual) or (op_PK_movimento = maior_ou_igual) then
      clausula_where := clausula_where + ' and pk_movimentos_cgd ' + op_PK_movimento + E_PK_movimento.Text
    else if (op_PK_movimento = like) then
      clausula_where := clausula_where + ' and pk_movimentos_cgd::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_PK_movimento.Text + percentagem + (chr(39))
    else if (op_PK_movimento = between) then
      clausula_where := clausula_where + ' and pk_movimentos_cgd ' + espaco + between + espaco + stringReplace(E_PK_movimento.Text,'*',' and ',[rfReplaceAll])
    else if (op_PK_movimento = interrogacao) then
      begin

//      clausula_where := clausula_where + ' and pk_movimentos_cgd ' + espaco + between + espaco + stringReplace(E_PK_movimento.Text,'*',' and ',[rfReplaceAll]);

      end;
  end;
//
  if E_data_mov.Text <> '' then
  begin
    if (op_data_mov = igual_a) or (op_data_mov = menor_que) or (op_data_mov = maior_que) or (op_data_mov = menor_ou_igual) or (op_data_mov = maior_ou_igual) then
      clausula_where := clausula_where + ' and data_mov ' +  op_data_mov + chr(39) + E_data_mov.Text + chr(39)
    else if op_data_mov = like then
      clausula_where := clausula_where + ' and data_mov::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_data_mov.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and data_mov ' + espaco + between + espaco + plica + stringReplace(E_data_mov.Text,'*',''' and ''',[rfReplaceAll]) + plica;
  end;
//
  if E_data_valor.Text <> '' then
  begin
    if (op_data_valor = igual_a) or (op_data_valor = menor_que) or (op_data_valor = maior_que) or (op_data_valor = menor_ou_igual) or (op_data_valor = maior_ou_igual) then
      clausula_where := clausula_where + ' and data_valor ' +  op_data_valor + plica +  E_data_valor.Text + plica
    else if op_data_valor = like then
      clausula_where := clausula_where + ' and data_valor::text ' + espaco +  like  + espaco + plica + percentagem + E_data_valor.Text + percentagem + plica
    else
      clausula_where := clausula_where + ' and data_valor ' + espaco + between + espaco + plica + stringReplace(E_data_valor.Text,'*',''' and ''',[rfReplaceAll]) + plica;
  end;
//
  if E_descricao.Text <> '' then
  begin
    E_descricao.Text := UpperCase(E_descricao.Text);
    if (op_descricao = igual_a) then
      clausula_where := clausula_where + ' and trim(descricao) ' +  op_descricao + espaco +  plica + E_descricao.Text + plica
    else    //if op_descricao = like then
      clausula_where := clausula_where + ' and trim(upper(descricao))::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_descricao.Text + percentagem + (chr(39));
  end;
//
  if E_debito.Text <> '' then
  begin
    E_debito.Text := stringReplace(E_debito.Text,',','.',[rfReplaceAll]);
    if (op_debito = igual_a) or (op_debito = menor_que) or (op_debito = maior_que) or (op_debito = menor_ou_igual) or (op_debito = maior_ou_igual) then
      clausula_where := clausula_where + ' and debito ' + op_debito + E_debito.Text
    else if (op_debito = like) then
      clausula_where := clausula_where + ' and debito::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_debito.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and debito ' + espaco + between + espaco + stringReplace(E_debito.Text,'*',' and ',[rfReplaceAll]);
  end;
//
  if E_credito.Text <> '' then
  begin
    E_credito.Text := stringReplace(E_credito.Text,',','.',[rfReplaceAll]);
    if (op_credito = igual_a) or (op_credito = menor_que) or (op_credito = maior_que) or (op_credito = menor_ou_igual) or (op_credito = maior_ou_igual) then
      clausula_where := clausula_where + ' and credito ' + op_credito + E_credito.Text
    else if (op_credito = like) then
      clausula_where := clausula_where + ' and credito::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_credito.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and credito ' + espaco + between + espaco + stringReplace(E_credito.Text,'*',' and ',[rfReplaceAll]);
  end;
  //
  if E_saldo_contabilistico.Text <> '' then
  begin
    E_saldo_contabilistico.Text := stringReplace(E_saldo_contabilistico.Text,',','.',[rfReplaceAll]);
    if (op_saldo_contabilistico = igual_a) or (op_saldo_contabilistico = menor_que) or (op_saldo_contabilistico = maior_que) or (op_saldo_contabilistico = menor_ou_igual) or (op_saldo_contabilistico = maior_ou_igual) then
      clausula_where := clausula_where + ' and saldo_contabilistico ' + op_saldo_contabilistico + E_saldo_contabilistico.Text
    else if (op_saldo_contabilistico = like) then
      clausula_where := clausula_where + ' and saldo_contabilistico::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_saldo_contabilistico.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and saldo_contabilistico ' + espaco + between + espaco + stringReplace(E_saldo_contabilistico.Text,'*',' and ',[rfReplaceAll]);
  end;
//
  if E_saldo_disponivel.Text <> '' then
    begin
      E_saldo_disponivel.Text := stringReplace(E_saldo_disponivel.Text,',','.',[rfReplaceAll]);
      if (op_saldo_disponivel = igual_a) or (op_saldo_disponivel = menor_que) or (op_saldo_disponivel = maior_que) or (op_saldo_disponivel = menor_ou_igual) or (op_saldo_disponivel = maior_ou_igual) then
        clausula_where := clausula_where + ' and saldo_disponivel ' + op_saldo_disponivel + E_saldo_disponivel.Text
      else if (op_saldo_disponivel = like) then
        clausula_where := clausula_where + ' and saldo_disponivel::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_saldo_disponivel.Text + percentagem + (chr(39))
      else
        clausula_where := clausula_where + ' and saldo_disponivel ' + espaco + between + espaco + stringReplace(E_saldo_disponivel.Text,'*',' and ',[rfReplaceAll]);
    end;
//
  if E_categoria.Text <> '' then
  begin
    E_categoria.Text := UpperCase(E_categoria.Text);
    if (op_categoria = igual_a) then
      clausula_where := clausula_where + ' and trim(categoria) ' +  op_categoria + espaco +  plica + E_categoria.Text + plica
    else    //if op_categoria = like then
      clausula_where := clausula_where + ' and trim(categoria)::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_categoria.Text + percentagem + (chr(39));
  end;
//
  if E_cod_tipo_movimento.Text <> '' then
  begin
    E_cod_tipo_movimento.Text := stringReplace(E_cod_tipo_movimento.Text,',','.',[rfReplaceAll]);
    if (op_cod_tipo_movimento = igual_a) or (op_cod_tipo_movimento = menor_que) or (op_cod_tipo_movimento = maior_que) or (op_cod_tipo_movimento = menor_ou_igual) or (op_cod_tipo_movimento = maior_ou_igual) then
      clausula_where := clausula_where + ' and cod_tipo_movimento ' + op_cod_tipo_movimento + E_cod_tipo_movimento.Text
    else if (op_cod_tipo_movimento = like) then
      clausula_where := clausula_where + ' and cod_tipo_movimento::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_cod_tipo_movimento.Text + percentagem + (chr(39))
    else
      clausula_where := clausula_where + ' and cod_tipo_movimento ' + espaco + between + espaco + stringReplace(E_cod_tipo_movimento.Text,'*',' and ',[rfReplaceAll]);
  end;
//
  if E_analisado.Text <> '' then
  begin
    E_analisado.Text := UpperCase(E_analisado.Text);
    if (op_analisado = igual_a) then
      clausula_where := clausula_where + ' and trim(analisado) ' +  op_analisado + espaco +  plica + E_analisado.Text + plica
    else    //if op_analisado = like then
      clausula_where := clausula_where + ' and trim(analisado)::text ' + espaco +  like  + espaco + chr(39) + percentagem + E_analisado.Text + percentagem + (chr(39));
  end;

//  SQL_Text := 'select * from sch_conta.movimentos_cgd ' + clausula_where + ' order by pk_movimentos_cgd ASC';   // completa a formação da instrução SQL a sujeitar à BD
  SQL_Text := 'select * from sch_conta.movimentos_cgd ' + clausula_where + ' order by data_mov ASC';   // completa a formação da instrução SQL a sujeitar à BD

  frm_dm_movimentos.SQLQ_movimentos_CGD.SQL.Text := SQL_Text;
  frm_dm_movimentos.SQLQ_movimentos_CGD.Active := FALSE;
  showmessage(frm_dm_movimentos.SQLQ_movimentos_CGD.SQL.Text);
  frm_dm_movimentos.SQLQ_movimentos_CGD.Active := TRUE;

  frm_dm_movimentos.SQLQ_total_movimentos_CGD.Refresh;    // refresca a contagem de movimentos na BD

  E_saldo_contabilistico.visible := FALSE;
  E_data_valor.visible := FALSE;
  E_credito.visible := FALSE;
  E_descricao.visible := FALSE;
  E_debito.visible := FALSE;
  E_PK_movimento.visible := FALSE;
  E_data_mov.visible := FALSE;
  E_saldo_disponivel.visible := FALSE;
  E_categoria.visible := FALSE;
  E_analisado.visible := FALSE;
//
  L_saldo_contabilistico.visible := FALSE;
  L_data_valor.visible := FALSE;
  L_credito.visible := FALSE;
  L_descricao.visible := FALSE;
  L_debito.visible := FALSE;
  L_PK_movimento.visible := FALSE;
  L_data_mov.visible := FALSE;
  L_saldo_disponivel.visible := FALSE;
  L_categoria.visible := FALSE;
  L_analisado.visible := FALSE;

  Hide;
end;

procedure Tfrm_prep_query_cgd_movimentos.B_LimparClick(Sender: TObject);
begin
  E_PK_movimento.Clear;
  CB_op_pk_movimento.Clear;
  CB_op_pk_movimento.Text := 'Operador';
  CB_op_pk_movimento.Visible := FALSE;

  E_data_mov.Clear;
  CB_op_data_mov.Clear;
  CB_op_data_mov.Text := 'Operador';
  CB_op_data_mov.Visible := FALSE;

  E_data_valor.Clear;
  CB_op_data_valor.Clear;
  CB_op_data_valor.Text := 'Operador';
  CB_op_data_valor.Visible := FALSE;

  E_descricao.Clear;
  CB_op_descricao.Clear;
  CB_op_descricao.Text := 'Operador';
  CB_op_descricao.Visible := FALSE;

  E_debito.Clear;
  CB_op_debito.Clear;
  CB_op_debito.Text := 'Operador';
  CB_op_debito.Visible := FALSE;

  E_credito.Clear;
  CB_op_credito.Clear;
  CB_op_credito.Text := 'Operador';
  CB_op_credito.Visible := FALSE;

  E_saldo_contabilistico.Clear;
  CB_op_saldo_contabilistico.Clear;
  CB_op_saldo_contabilistico.Text := 'Operador';
  CB_op_saldo_contabilistico.Visible := FALSE;

  E_saldo_disponivel.Clear;
  CB_op_saldo_disponivel.Clear;
  CB_op_saldo_disponivel.Text := 'Operador';
  CB_op_saldo_disponivel.Visible := FALSE;

  E_categoria.Clear;
  CB_op_categoria.Clear;
  CB_op_categoria.Text := 'Operador';
  CB_op_categoria.Visible := FALSE;

  E_cod_tipo_movimento.Clear;
  CB_op_cod_tipo_movimento.Clear;
  CB_op_cod_tipo_movimento.Text := 'Operador';
  CB_op_cod_tipo_movimento.Visible := FALSE;

  E_analisado.Clear;
  CB_op_analisado.Clear;
  CB_op_analisado.Text := 'Operador';
  CB_op_analisado.Visible := FALSE;
end;

procedure Tfrm_prep_query_cgd_movimentos.B_SairClick(Sender: TObject);
begin
  Hide;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_analisadoEnter(Sender: TObject);
begin
  E_analisado.Width := 50;
  CB_op_analisado.Items.Clear;
  CB_op_analisado.Text:= 'Operador';
  CB_op_analisado.Items.Add('  >  ');
  CB_op_analisado.Items.Add('  <  ');
  CB_op_analisado.Items.Add('  =  ' );
  CB_op_analisado.Items.Add('  <=  ' );
  CB_op_analisado.Items.Add('  >=  ' );
  CB_op_analisado.Items.Add('  between  ');
  CB_op_analisado.Items.Add('  like  ');
  CB_op_analisado.Color := $0064FFFF;
  CB_op_analisado.Visible := TRUE;

  CB_op_analisado.Left := E_analisado.Left + E_analisado.Width + 5;
  CB_op_analisado.Top := E_analisado.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.CB_op_cod_tipo_movimentoChange(Sender: TObject);
begin
  case CB_op_cod_tipo_movimento.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_cod_tipo_movimento:= '>';
    1: op_cod_tipo_movimento := '<';
    2: op_cod_tipo_movimento := '=';
    3: op_cod_tipo_movimento := '<=';
    4: op_cod_tipo_movimento := '>=';
    5: op_cod_tipo_movimento := 'between';
    6: op_cod_tipo_movimento := 'like';
  end;
end;

procedure Tfrm_prep_query_cgd_movimentos.CB_op_saldo_contabilisticoChange(Sender: TObject);
begin
  case CB_op_saldo_contabilistico.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_saldo_contabilistico := '>';
    1: op_saldo_contabilistico := '<';
    2: op_saldo_contabilistico := '=';
    3: op_saldo_contabilistico := '<=';
    4: op_saldo_contabilistico := '>=';
    5: op_saldo_contabilistico := 'between';
    6: op_saldo_contabilistico := 'like';
  end;
end;

procedure Tfrm_prep_query_cgd_movimentos.CB_op_saldo_disponivelChange(Sender: TObject);
begin
  case CB_op_saldo_disponivel.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_saldo_disponivel := '>';
    1: op_saldo_disponivel := '<';
    2: op_saldo_disponivel := '=';
    3: op_saldo_disponivel := '<=';
    4: op_saldo_disponivel := '>=';
    5: op_saldo_disponivel := 'between';
    6: op_saldo_disponivel := 'like';
  end;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_categoriaEnter(Sender: TObject);
begin
  E_categoria.Width := 140;
  CB_op_categoria.Items.Clear;
  CB_op_categoria.Text:= 'Operador';
  CB_op_categoria.Items.Add('  >  ');
  CB_op_categoria.Items.Add('  <  ');
  CB_op_categoria.Items.Add('  =  ' );
  CB_op_categoria.Items.Add('  <=  ' );
  CB_op_categoria.Items.Add('  >=  ' );
  CB_op_categoria.Items.Add('  between  ');
  CB_op_categoria.Items.Add('  like  ');
  CB_op_categoria.Color := $0064FFFF;
  CB_op_categoria.Visible := TRUE;

  CB_op_categoria.Left := E_categoria.Left + E_categoria.Width + 5;
  CB_op_categoria.Top := E_categoria.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_cod_tipo_movimentoEnter(Sender: TObject);
begin
  E_cod_tipo_movimento.Width := 50;
  CB_op_cod_tipo_movimento.Items.Clear;
  CB_op_cod_tipo_movimento.Text:= 'Operador';
  CB_op_cod_tipo_movimento.Items.Add('  >  ');
  CB_op_cod_tipo_movimento.Items.Add('  <  ');
  CB_op_cod_tipo_movimento.Items.Add('  =  ' );
  CB_op_cod_tipo_movimento.Items.Add('  <=  ' );
  CB_op_cod_tipo_movimento.Items.Add('  >=  ' );
  CB_op_cod_tipo_movimento.Items.Add('  between  ');
  CB_op_cod_tipo_movimento.Items.Add('  like  ');
  CB_op_cod_tipo_movimento.Color := $0064FFFF;
  CB_op_cod_tipo_movimento.Visible := TRUE;

  CB_op_cod_tipo_movimento.Left := E_cod_tipo_movimento.Left + E_cod_tipo_movimento.Width + 5;
  CB_op_cod_tipo_movimento.Top := E_cod_tipo_movimento.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_creditoEnter(Sender: TObject);
begin
  E_credito.Width := 100;
  CB_op_credito.Items.Clear;
  CB_op_credito.Text:= 'Operador';
  CB_op_credito.Items.Add('  >  ');
  CB_op_credito.Items.Add('  <  ');
  CB_op_credito.Items.Add('  =  ' );
  CB_op_credito.Items.Add('  <=  ' );
  CB_op_credito.Items.Add('  >=  ' );
  CB_op_credito.Items.Add('  between  ');
  CB_op_credito.Items.Add('  like  ');
  CB_op_credito.Color := $0064FFFF;
  CB_op_credito.Visible := TRUE;

  CB_op_credito.Left := E_credito.Left + E_credito.Width + 5;
  CB_op_credito.Top := E_credito.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_descricaoEnter(Sender: TObject);
begin
  E_descricao.Width := 225;
  CB_op_descricao.Items.Clear;
  CB_op_descricao.Text:= 'Operador';
  CB_op_descricao.Items.Add('  >  ');
  CB_op_descricao.Items.Add('  <  ');
  CB_op_descricao.Items.Add('  =  ' );
  CB_op_descricao.Items.Add('  <=  ' );
  CB_op_descricao.Items.Add('  >=  ' );
  CB_op_descricao.Items.Add('  between  ');
  CB_op_descricao.Items.Add('  like  ');
  CB_op_descricao.Color := $0064FFFF;
  CB_op_descricao.Visible := TRUE;

  CB_op_descricao.Left := E_descricao.Left + E_descricao.Width + 5;
  CB_op_descricao.Top := E_descricao.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_PK_movimentoEnter(Sender: TObject);
begin
  E_PK_movimento.Width := 80;
  CB_op_pk_movimento.Items.Clear;
  CB_op_pk_movimento.Text := 'Operador';
  CB_op_pk_movimento.Items.Add('  >  ');
  CB_op_pk_movimento.Items.Add('  <  ');
  CB_op_pk_movimento.Items.Add('  =  ' );
  CB_op_pk_movimento.Items.Add('  <=  ' );
  CB_op_pk_movimento.Items.Add('  >=  ' );
  CB_op_pk_movimento.Items.Add('  between  ');
  CB_op_pk_movimento.Items.Add('  like  ');
//  CB_op_pk_movimento.Items.Add('  ?  ');  // igual ao seguinte
  CB_op_pk_movimento.Color := $0064FFFF;
  CB_op_pk_movimento.Visible := TRUE;

  CB_op_pk_movimento.Left := E_PK_movimento.Left + E_PK_movimento.Width + 5;
  CB_op_pk_movimento.Top := E_PK_movimento.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_saldo_contabilisticoEnter(Sender: TObject);
begin
  E_saldo_contabilistico.Width := 100;
  CB_op_saldo_contabilistico.Items.Clear;
  CB_op_saldo_contabilistico.Text:= 'Operador';
  CB_op_saldo_contabilistico.Items.Add('  >  ');
  CB_op_saldo_contabilistico.Items.Add('  <  ');
  CB_op_saldo_contabilistico.Items.Add('  =  ' );
  CB_op_saldo_contabilistico.Items.Add('  <=  ' );
  CB_op_saldo_contabilistico.Items.Add('  >=  ' );
  CB_op_saldo_contabilistico.Items.Add('  between  ');
  CB_op_saldo_contabilistico.Items.Add('  like  ');
  CB_op_saldo_contabilistico.Color := $0064FFFF;
  CB_op_saldo_contabilistico.Visible := TRUE;

  CB_op_saldo_contabilistico.Left := E_saldo_contabilistico.Left + E_saldo_contabilistico.Width + 5;
  CB_op_saldo_contabilistico.Top := E_saldo_contabilistico.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_saldo_disponivelEnter(Sender: TObject);
begin
  E_saldo_disponivel.Width := 100;
  CB_op_saldo_disponivel.Items.Clear;
  CB_op_saldo_disponivel.Text:= 'Operador';
  CB_op_saldo_disponivel.Items.Add('  >  ');
  CB_op_saldo_disponivel.Items.Add('  <  ');
  CB_op_saldo_disponivel.Items.Add('  =  ' );
  CB_op_saldo_disponivel.Items.Add('  <=  ' );
  CB_op_saldo_disponivel.Items.Add('  >=  ' );
  CB_op_saldo_disponivel.Items.Add('  between  ');
  CB_op_saldo_disponivel.Items.Add('  like  ');
  CB_op_saldo_disponivel.Color := $0064FFFF;
  CB_op_saldo_disponivel.Visible := TRUE;

  CB_op_saldo_disponivel.Left := E_saldo_disponivel.Left + E_saldo_disponivel.Width + 5;
  CB_op_saldo_disponivel.Top := E_saldo_disponivel.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.CB_op_pk_movimentoChange(Sender: TObject);
begin
  case CB_op_pk_movimento.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_PK_movimento := '>';
    1: op_PK_movimento := '<';
    2: op_PK_movimento := '=';
    3: op_PK_movimento := '<=';
    4: op_PK_movimento := '>=';
    5: op_PK_movimento := 'between';
    6: op_PK_movimento := 'like';
    7: op_PK_movimento := 'SQL_livre';
  end;
end;


procedure Tfrm_prep_query_cgd_movimentos.CB_op_data_movChange(Sender: TObject);
begin
  case CB_op_data_mov.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_data_mov := '>';
    1: op_data_mov := '<';
    2: op_data_mov := '=';
    3: op_data_mov := '<=';
    4: op_data_mov := '>=';
    5: op_data_mov := 'between';
    6: op_data_mov := 'like';
  end;
end;

procedure Tfrm_prep_query_cgd_movimentos.CB_op_creditoChange(Sender: TObject);
begin
  case CB_op_credito.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_credito := '>';
    1: op_credito := '<';
    2: op_credito := '=';
    3: op_credito := '<=';
    4: op_credito := '>=';
    5: op_credito := 'between';
    6: op_credito := 'like';
  end;
end;

procedure Tfrm_prep_query_cgd_movimentos.CB_op_data_valorChange(Sender: TObject);
begin
  case CB_op_data_valor.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_data_valor := '>';
    1: op_data_valor := '<';
    2: op_data_valor := '=';
    3: op_data_valor := '<=';
    4: op_data_valor := '>=';
    5: op_data_valor := 'between';
    6: op_data_valor := 'like';
  end;
end;

procedure Tfrm_prep_query_cgd_movimentos.CB_op_debitoChange(Sender: TObject);
begin
  case CB_op_debito.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_debito := '>';
    1: op_debito := '<';
    2: op_debito := '=';
    3: op_debito := '<=';
    4: op_debito := '>=';
    5: op_debito := 'between';
    6: op_debito := 'like';
  end;
end;

procedure Tfrm_prep_query_cgd_movimentos.CB_op_descricaoChange(Sender: TObject);
begin
  case CB_op_descricao.ItemIndex of  //what entry (which item) has currently been chosen
    0: op_descricao := '>';
    1: op_descricao := '<';
    2: op_descricao := '=';
    3: op_descricao := '<=';
    4: op_descricao := '>=';
    5: op_descricao := 'between';
    6: op_descricao := 'like';
  end;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_data_movEnter(Sender: TObject);
begin
  E_data_mov.Width := 105;
  CB_op_data_mov.Items.Clear;
  CB_op_data_mov.Text:= 'Operador';
  CB_op_data_mov.Items.Add('  >  ');
  CB_op_data_mov.Items.Add('  <  ');
  CB_op_data_mov.Items.Add('  =  ' );
  CB_op_data_mov.Items.Add('  <=  ' );
  CB_op_data_mov.Items.Add('  >=  ' );
  CB_op_data_mov.Items.Add('  between  ');
  CB_op_data_mov.Items.Add('  like  ');
  CB_op_data_mov.Color := $0064FFFF;
  CB_op_data_mov.Visible := TRUE;

  CB_op_data_mov.Left := E_data_mov.Left + E_data_mov.Width + 5;
  CB_op_data_mov.Top := E_data_mov.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_data_valorEnter(Sender: TObject);
begin
  E_data_valor.Width := 105;
  CB_op_data_valor.Items.Clear;
  CB_op_data_valor.Text:= 'Operador';
  CB_op_data_valor.Items.Add('  >  ');
  CB_op_data_valor.Items.Add('  <  ');
  CB_op_data_valor.Items.Add('  =  ' );
  CB_op_data_valor.Items.Add('  <=  ' );
  CB_op_data_valor.Items.Add('  >=  ' );
  CB_op_data_valor.Items.Add('  between  ');
  CB_op_data_valor.Items.Add('  like  ');
  CB_op_data_valor.Color := $0064FFFF;
  CB_op_data_valor.Visible := TRUE;

  CB_op_data_valor.Left := E_data_valor.Left + E_data_valor.Width + 5;
  CB_op_data_valor.Top := E_data_valor.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.E_debitoEnter(Sender: TObject);
begin
  E_debito.Width := 100;
  CB_op_debito.Items.Clear;
  CB_op_debito.Text:= 'Operador';
  CB_op_debito.Items.Add('  >  ');
  CB_op_debito.Items.Add('  <  ');
  CB_op_debito.Items.Add('  =  ' );
  CB_op_debito.Items.Add('  <=  ' );
  CB_op_debito.Items.Add('  >=  ' );
  CB_op_debito.Items.Add('  between  ');
  CB_op_debito.Items.Add('  like  ');
  CB_op_debito.Color := $0064FFFF;
  CB_op_debito.Visible := TRUE;

  CB_op_debito.Left := E_debito.Left + E_debito.Width + 5;
  CB_op_debito.Top := E_debito.Top;
end;

procedure Tfrm_prep_query_cgd_movimentos.FormCreate(Sender: TObject);
begin
//  DragMode
  E_PK_movimento.DragMode := dmAutomatic;
  L_PK_movimento.DragMode := dmAutomatic;
  E_PK_movimento.DragMode := dmAutomatic;
  L_PK_movimento.DragMode := dmAutomatic;
  E_data_mov.DragMode := dmAutomatic;
  L_data_mov.DragMode := dmAutomatic;
  E_data_valor.DragMode := dmAutomatic;
  L_data_valor.DragMode := dmAutomatic;
  E_descricao.DragMode := dmAutomatic;
  L_descricao.DragMode := dmAutomatic;
  E_debito.DragMode := dmAutomatic;
  L_debito.DragMode := dmAutomatic;
  E_credito.DragMode := dmAutomatic;
  L_credito.DragMode := dmAutomatic;
  E_saldo_contabilistico.DragMode := dmAutomatic;
  L_saldo_contabilistico.DragMode := dmAutomatic;
  E_saldo_disponivel.DragMode := dmAutomatic;
  L_saldo_disponivel.DragMode := dmAutomatic;
  E_categoria.DragMode := dmAutomatic;
  L_categoria.DragMode := dmAutomatic;
  E_cod_tipo_movimento.DragMode := dmAutomatic;
  L_cod_tipo_movimento.DragMode := dmAutomatic;
  E_analisado.DragMode := dmAutomatic;
  L_analisado.DragMode := dmAutomatic;

  Top := frm_edita_cgd_movimentos.Top + 120;
  Left := frm_edita_cgd_movimentos.Left + 700;
end;

procedure Tfrm_prep_query_cgd_movimentos.FormHide(Sender: TObject);
var
  i:integer;
begin
  for i := 0 to frm_edita_cgd_movimentos.DBG_movimentos.Columns.Count -1 do      // limpa os UP e DOWN dos títulos de todas as colunas antes de cada ordenação por qualquer coluna
  begin
    frm_edita_cgd_movimentos.DBG_movimentos.Columns.Items[i].Title.ImageIndex := 2;
  end;
end;

end.
